From 26db919ac1ddcc3c3c496800a18f1f18ed419319 Mon Sep 17 00:00:00 2001
From: Jana Librova <jcupova@redhat.com>
Date: Sep 04 2024 07:17:14 +0000
Subject: [PATCH 8/11] Fix code review


---

diff --git a/plugins/builder/taskrepos.conf b/plugins/builder/taskrepos.conf
index 1fa3e61..6d7c98c 100644
--- a/plugins/builder/taskrepos.conf
+++ b/plugins/builder/taskrepos.conf
@@ -26,4 +26,4 @@ email_template : From: %%(from_addr)s
     If you found a bug or you wish to stop these emails, please create a ticket:
     %%(ticketlink)s
 
-    Source code at %%(sourcecode)s
\ No newline at end of file
+    Source code at %%(sourcecodelink)s
\ No newline at end of file
diff --git a/plugins/builder/taskrepos.py b/plugins/builder/taskrepos.py
index c301452..d425fc5 100644
--- a/plugins/builder/taskrepos.py
+++ b/plugins/builder/taskrepos.py
@@ -1,21 +1,17 @@
 # kojid plugin
 
-from __future__ import absolute_import
-
 import os
-import six
 import smtplib
 import subprocess
 
+import six
+
 import koji
-import koji.tasks
-from koji.tasks import (
-    BaseTaskHandler
-)
+from koji.tasks import BaseTaskHandler
 from koji.util import joinpath
 
 
-__all__ = ('TaskReposTask', 'tasksRepoNotifications')
+__all__ = ('TaskReposTask', 'taskRepoNotifications')
 
 CONFIG_FILE = '/etc/kojid/plugins/taskrepos.conf'
 config = None
@@ -27,7 +23,7 @@ def read_config():
     config = {
         'repo_lifetime': 14,  # days
         'ticketlink': '',
-        'sourcecode': '',
+        'sourcecodelink': '',
         'email_template': '',
     }
 
@@ -39,13 +35,13 @@ def read_config():
         config['ticketlink'] = cp.get('taskrepos', 'ticketlink')
 
     if cp.has_option('taskrepos', 'sourcecodelink'):
-        config['sourcecode'] = cp.get('taskrepos', 'sourcecodelink')
+        config['sourcecodelink'] = cp.get('taskrepos', 'sourcecodelink')
 
     if cp.has_option('taskrepos', 'email_template'):
         config['email_template'] = cp.get('taskrepos', 'email_template')
 
 
-class TaskReposTask(koji.tasks.BaseTaskHandler):
+class TaskReposTask(BaseTaskHandler):
 
     Methods = ['taskrepos']
     _taskWeight = 2.0
@@ -122,22 +118,30 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
                     self.logger.info('PkgLINE %s' % pkg)
         return dest_dirs
 
-    def create_repos(self, taskinfo):
-        builds = self.session.listBuilds(taskID=taskinfo['parent'])
-        if builds:
-            repotype = 'official'
-        else:
-            repotype = 'scratch'
+    def create_repos(self, tasksinfo):
+        if len(tasksinfo) != 0:
+            builds = self.session.listBuilds(taskID=tasksinfo[0]['parent'])
+            if builds:
+                repotype = 'official'
+            else:
+                repotype = 'scratch'
         info = None
         rpms = []
-        results = self.session.getTaskResult(taskinfo['id'])
-        if results.get('srpms'):
+        results = {
+            'rpms': [],
+            'srpms': [],
+        }
+        for taskinfo in tasksinfo:
+            task_result = self.session.getTaskResult(taskinfo['id'])
+            results['rpms'].extend(task_result['rpms'])
+            results['srpms'].extend(task_result['srpms'])
+        if results['srpms'] != []:
             srpm = results['srpms'][0]
             srpmname = os.path.basename(results['srpms'][0])
             info = koji.parse_NVRA(srpmname)
         if info is None:
             raise koji.GenericError("SRPM is missing.")
-        if results.get('rpms'):
+        if results['rpms'] != []:
             rpms.extend(results['rpms'])
         repodir = joinpath(self.workdir, info['name'], info['version'], info['release'])
         repodir_nvr = joinpath(repotype, info['name'], info['version'], info['release'])
@@ -153,20 +157,21 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
             self.merge_arch_repo(arch, repodir, repodir)
         return repodir, repodir_nvr, nvr
 
-    def write_repo_file(self, task, repodir, nvr):
-        parent_taskinfo = self.session.getTaskInfo(task['parent'], request=True)
-        if len(parent_taskinfo['request']) > 2:
-            for tr in parent_taskinfo['request']:
+    def write_repo_file(self, taskinfo, buildarch_subtasks, repodir, nvr):
+        if len(taskinfo['request']) > 2:
+            for tr in taskinfo['request']:
                 if isinstance(tr, dict):
                     scratch = tr.get('scratch', False)
         else:
             scratch = False
         baseurl = joinpath(self.options.topurl, 'repos-tasks', 'tasks', str(self.id % 10000),
                            str(self.id))
-        if 'noarch' == task["label"]:
-            baseurl = '%s/noarch/' % baseurl
-        else:
-            baseurl = '%s/%s/' % (baseurl, '$basearch')
+        baseurls = []
+        for subtaskinfo in buildarch_subtasks:
+            if 'noarch' == subtaskinfo["label"]:
+                baseurls.append('%s/noarch/' % baseurl)
+            else:
+                baseurls.append('%s/%s/' % (baseurl, '$basearch'))
         repo_file_name = nvr
         repo_name = 'brew-task-repo-%s' % nvr.replace('+', '_')
         build = 'build'
@@ -178,15 +183,16 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
         repo_file = '%s/%s' % (repodir, repo_file_name)
 
         with koji._open_text_file(repo_file, 'w') as repo_fd:
-            repo_fd.write(
-                """[%s]
+            for baseurl in baseurls:
+                repo_fd.write(
+                    """[%s]
 name=Repo for Brew %s of %s
 enabled=1
 gpgcheck=0
 baseurl=%s
 module_hotfixes=1
 """ % (repo_name, build, nvr, baseurl)
-            )
+                )
         self.logger.debug('Wrote repo file to %s' % repo_file)
         return baseurl
 
@@ -214,53 +220,42 @@ module_hotfixes=1
                 repo_files.append(relpath)
         return repo_files, repos, repopath_part
 
-    def handler(self, task_id_child, task_link=False):
+    def handler(self, task_id, task_link=False):
         read_config()
         data = {}
-        if not isinstance(task_id_child, int):
-            task_id_child = int(task_id_child)
-        taskinfo = self.session.getTaskInfo(task_id_child, request=True)
+        if not isinstance(task_id, int):
+            task_id = int(task_id)
+        taskinfo = self.session.getTaskInfo(task_id, request=True)
         policy_data = {
             'user_id': taskinfo['owner'],
         }
         self.session.host.assertPolicy('taskrepos', policy_data)
         if not taskinfo:
-            raise koji.BuildError('Invalid task ID: %s' % task_id_child)
-        if taskinfo['method'] != 'buildArch':
-            raise koji.BuildError('%s is not a build task' % task_id_child)
+            raise koji.BuildError('Invalid task ID: %s' % task_id)
+        if taskinfo['method'] != 'build':
+            raise koji.BuildError('%s is not a build task' % task_id)
         if taskinfo['state'] != 2:
             raise koji.BuildError('task %s has not completed successfully' % taskinfo['id'])
-        repodir, repodir_nvr, data['nvr'] = self.create_repos(taskinfo)
-        self.logger.debug('Repos for task %s created under %s' % (task_id_child, repodir))
-        data['baseurl'] = self.write_repo_file(taskinfo, repodir, data['nvr'])
+        buildarch_subtasks = [subtask for subtask in self.session.getTaskChildren(task_id)
+                              if subtask['method'] == 'buildArch']
+        repodir, repodir_nvr, data['nvr'] = self.create_repos(buildarch_subtasks)
+        self.logger.debug('Repos for task %s created under %s' % (task_id, repodir))
+        data['baseurl'] = self.write_repo_file(taskinfo, buildarch_subtasks, repodir, data['nvr'])
         repo_files, repos, repopath_part = self.upload_repo(repodir)
         data['owner'] = self.session.getUser(taskinfo['owner'])['name']
-        data['repo_urls'], uploadpath, data['old_repodir'] = self.session.taskRepoDone(
+        data['repo_urls'], uploadpath, data['old_repodir'] = self.session.host.taskRepoDone(
             self.id, repos, repodir_nvr, self.options.topurl, task_link)
         data['repodir'] = joinpath(koji.pathinfo.topdir, 'repos-tasks', repodir_nvr)
-        self.session.host.tasksRepoNotifications(self.id, data)
+        self.session.host.taskRepoNotifications(self.id, data)
         return [uploadpath, repo_files]
 
 
-class tasksRepoNotifications(BaseTaskHandler):
-    Methods = ['tasksRepoNotifications']
+class taskRepoNotifications(BaseTaskHandler):
+    Methods = ['taskRepoNotifications']
     _taskWeight = 0.1
-    INI_FILE = '/etc/kojid/plugins/taskrepos.ini'
-    ini_config = ''
-
-    def read_ini_file(self):
-        cp_ini = koji.read_config_files(self.INI_FILE)
-        self.ini_config = {
-            'email_template': '',
-        }
-
-        # expire repos in days
-        if cp_ini.has_option('EMAIL TEMPLATE', 'email_template'):
-            self.ini_config['email_template'] = cp_ini.get('EMAIL TEMPLATE', 'email_template')
 
     def handler(self, recipient, data):
         read_config()
-        self.read_ini_file()
         data['from_addr'] = self.options.from_addr
         repo_urls = data['repo_urls'].copy()
         data['repo_urls'] = ''
@@ -277,7 +272,7 @@ class tasksRepoNotifications(BaseTaskHandler):
         else:
             data['old_repodir_msg'] = ''
         data['ticketlink'] = config['ticketlink']
-        data['sourcecode'] = config['sourcecode']
+        data['sourcecodelink'] = config['sourcecodelink']
         data['repolifetime'] = config['repo_lifetime']
         data['build'] = '-'.join(data['nvr'].split('-')[:-2])
         data['recipient'] = recipient
@@ -292,7 +287,7 @@ class tasksRepoNotifications(BaseTaskHandler):
         if self.options.smtp_user is not None and self.options.smtp_pass is not None:
             server.login(self.options.smtp_user, self.options.smtp_pass)
         # server.set_debuglevel(True)
-        server.sendmail(data['from_addr'], recipient, message)
+        server.sendmail(data['from_addr'], recipient, message.decode())
         server.quit()
 
         return 'sent notification of taskrepo %s to: %s' % (self.id, recipient)
diff --git a/plugins/hub/taskrepos_hub.py b/plugins/hub/taskrepos_hub.py
index 5191ef9..6a4ded0 100644
--- a/plugins/hub/taskrepos_hub.py
+++ b/plugins/hub/taskrepos_hub.py
@@ -3,16 +3,16 @@
 # plugin has a config file.  This hub plugin has no config file.
 
 
-import kojihub
 import logging
 import os
 
 import koji
+import kojihub
 from koji.context import context
-from koji.plugin import export, export_in, callback
+from koji.plugin import export_in, callback
 from koji.util import joinpath, safer_move, rmtree
 
-__all__ = ('taskrepos', 'tasksRepoNotifications', 'taskRepoDone')
+__all__ = ('taskrepos', 'taskRepoNotifications', 'taskRepoDone')
 
 
 logger = logging.getLogger('koji.hub')
@@ -32,7 +32,7 @@ def recursive_walk(dirpath, repo_urls, topurl, task_link):
     return repo_urls
 
 
-@export
+@export_in('host')
 def taskRepoDone(task_id, repos, repodir_nvr, topurl, task_link):
     repo_urls = []
     old_repodir = None
@@ -78,7 +78,7 @@ def taskrepos(cbtype, *args, **kws):
     task_id = kws['info']['id']
     task = kojihub.Task(task_id)
     taskinfo = task.getInfo()
-    if taskinfo['method'] != 'buildArch' or taskinfo['state'] != koji.TASK_STATES['CLOSED']:
+    if taskinfo['method'] != 'build' or taskinfo['state'] != koji.TASK_STATES['CLOSED']:
         return
     task_link = True
 
@@ -86,11 +86,11 @@ def taskrepos(cbtype, *args, **kws):
 
 
 @export_in('host')
-def tasksRepoNotifications(task_id, data):
+def taskRepoNotifications(task_id, data):
     if context.opts.get('DisableNotifications'):
         return
     email_domain = context.opts['EmailDomain']
     email = f"{data['owner']}@{email_domain}"
 
     data['task_id'] = task_id
-    kojihub.make_task('tasksRepoNotifications', [email, data])
+    kojihub.make_task('taskRepoNotifications', [email, data])

